import { Connector, Table, TypeIdentifier, TableRelation, PrimaryKey, PostgresConnectionDetails } from '../types/common';
import { Client } from 'pg';
export declare class PostgresConnector implements Connector {
    client: Client;
    connectionPromise: Promise<any>;
    constructor(connectionDetails: PostgresConnectionDetails);
    listSchemas(): Promise<string[]>;
    listTables(schemaName: string): Promise<Table[]>;
    queryTableColumns(schemaName: string): Promise<{
        [key: string]: any[];
    }>;
    queryPrimaryKeys(schemaName: string): Promise<PrimaryKey[]>;
    queryRelations(schemaName: string): Promise<TableRelation[]>;
    querySchemas(): Promise<any[]>;
    parseDefaultValue(string: any): any;
    toTypeIdentifier(type: string, field: string, isPrimaryKey: boolean): {
        typeIdentifier: TypeIdentifier | null;
        comment: string | null;
        error: string | null;
    };
}
